/* compile with gcc -ftrapv <filename> # gcc-4.8=no gcc-6.3=yes
 *   gcc -fsanitize=undefined <filename> # needs libubsan=centos-sclo-rh fail
 */
#include <signal.h>
#include <stdio.h>
#include <limits.h>

void signalHandler(int sig) {
  printf("Overflow detected\n");
}

int main() {
  signal(SIGABRT, &signalHandler);

  int largeInt = INT_MAX;
  int normalInt = 42;
  int overflowInt = largeInt + normalInt;  /* should cause overflow */

//  sleep(1);
  /* if compiling with -ftrapv, we shouldn't get here */
  return 0;
}

